<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>json-webtoken</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<h1 id="jsonwebtoken">jsonwebtoken</h1>
<table>
<thead>
<tr class="header">
<th><strong>Build</strong></th>
<th><strong>Dependency</strong></th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td><a href="http://travis-ci.org/auth0/node-jsonwebtoken"><img src="https://secure.travis-ci.org/auth0/node-jsonwebtoken.svg?branch=master" alt="Build Status" /></a></td>
<td><a href="https://david-dm.org/auth0/node-jsonwebtoken"><img src="https://david-dm.org/auth0/node-jsonwebtoken.svg" alt="Dependency Status" /></a></td>
</tr>
</tbody>
</table>
<p>An implementation of <a href="https://tools.ietf.org/html/rfc7519">JSON Web Tokens</a>.</p>
<p>This was developed against <code>draft-ietf-oauth-json-web-token-08</code>. It makes use of <a href="https://github.com/brianloveswords/node-jws">node-jws</a></p>
<h1 id="install">Install</h1>
<div class="sourceCode" id="cb1"><pre class="sourceCode bash"><code class="sourceCode bash"><a class="sourceLine" id="cb1-1" title="1">$ <span class="ex">npm</span> install jsonwebtoken</a></code></pre></div>
<h1 id="migration-notes">Migration notes</h1>
<ul>
<li><a href="https://github.com/auth0/node-jsonwebtoken/wiki/Migration-Notes:-v7-to-v8">From v7 to v8</a></li>
</ul>
<h1 id="usage">Usage</h1>
<h3 id="jwt.signpayload-secretorprivatekey-options-callback">jwt.sign(payload, secretOrPrivateKey, [options, callback])</h3>
<p>(Asynchronous) If a callback is supplied, the callback is called with the <code>err</code> or the JWT.</p>
<p>(Synchronous) Returns the JsonWebToken as string</p>
<p><code>payload</code> could be an object literal, buffer or string representing valid JSON. &gt; <strong>Please <em>note</em> that</strong> <code>exp</code> or any other claim is only set if the payload is an object literal. Buffer or string payloads are not checked for JSON validity.</p>
<blockquote>
<p>If <code>payload</code> is not a buffer or a string, it will be coerced into a string using <code>JSON.stringify</code>.</p>
</blockquote>
<p><code>secretOrPrivateKey</code> is a string, buffer, or object containing either the secret for HMAC algorithms or the PEM encoded private key for RSA and ECDSA. In case of a private key with passphrase an object <code>{ key, passphrase }</code> can be used (based on <a href="https://nodejs.org/api/crypto.html#crypto_sign_sign_private_key_output_format">crypto documentation</a>), in this case be sure you pass the <code>algorithm</code> option.</p>
<p><code>options</code>:</p>
<ul>
<li><code>algorithm</code> (default: <code>HS256</code>)</li>
<li><code>expiresIn</code>: expressed in seconds or a string describing a time span <a href="https://github.com/vercel/ms">vercel/ms</a>. &gt; Eg: <code>60</code>, <code>"2 days"</code>, <code>"10h"</code>, <code>"7d"</code>. A numeric value is interpreted as a seconds count. If you use a string be sure you provide the time units (days, hours, etc), otherwise milliseconds unit is used by default (<code>"120"</code> is equal to <code>"120ms"</code>).</li>
<li><code>notBefore</code>: expressed in seconds or a string describing a time span <a href="https://github.com/vercel/ms">vercel/ms</a>. &gt; Eg: <code>60</code>, <code>"2 days"</code>, <code>"10h"</code>, <code>"7d"</code>. A numeric value is interpreted as a seconds count. If you use a string be sure you provide the time units (days, hours, etc), otherwise milliseconds unit is used by default (<code>"120"</code> is equal to <code>"120ms"</code>).</li>
<li><code>audience</code></li>
<li><code>issuer</code></li>
<li><code>jwtid</code></li>
<li><code>subject</code></li>
<li><code>noTimestamp</code></li>
<li><code>header</code></li>
<li><code>keyid</code></li>
<li><code>mutatePayload</code>: if true, the sign function will modify the payload object directly. This is useful if you need a raw reference to the payload after claims have been applied to it but before it has been encoded into a token.</li>
</ul>
<blockquote>
<p>There are no default values for <code>expiresIn</code>, <code>notBefore</code>, <code>audience</code>, <code>subject</code>, <code>issuer</code>. These claims can also be provided in the payload directly with <code>exp</code>, <code>nbf</code>, <code>aud</code>, <code>sub</code> and <code>iss</code> respectively, but you <strong><em>can’t</em></strong> include in both places.</p>
</blockquote>
<p>Remember that <code>exp</code>, <code>nbf</code> and <code>iat</code> are <strong>NumericDate</strong>, see related <a href="#token-expiration-exp-claim">Token Expiration (exp claim)</a></p>
<p>The header can be customized via the <code>options.header</code> object.</p>
<p>Generated jwts will include an <code>iat</code> (issued at) claim by default unless <code>noTimestamp</code> is specified. If <code>iat</code> is inserted in the payload, it will be used instead of the real timestamp for calculating other things like <code>exp</code> given a timespan in <code>options.expiresIn</code>.</p>
<p>Synchronous Sign with default (HMAC SHA256)</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">var</span> jwt <span class="op">=</span> <span class="at">require</span>(<span class="st">&#39;jsonwebtoken&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="kw">var</span> token <span class="op">=</span> <span class="va">jwt</span>.<span class="at">sign</span>(<span class="op">{</span> <span class="dt">foo</span><span class="op">:</span> <span class="st">&#39;bar&#39;</span> <span class="op">},</span> <span class="st">&#39;shhhhh&#39;</span>)<span class="op">;</span></a></code></pre></div>
<p>Synchronous Sign with RSA SHA256</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="co">// sign with RSA SHA256</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="kw">var</span> privateKey <span class="op">=</span> <span class="va">fs</span>.<span class="at">readFileSync</span>(<span class="st">&#39;private.key&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="kw">var</span> token <span class="op">=</span> <span class="va">jwt</span>.<span class="at">sign</span>(<span class="op">{</span> <span class="dt">foo</span><span class="op">:</span> <span class="st">&#39;bar&#39;</span> <span class="op">},</span> privateKey<span class="op">,</span> <span class="op">{</span> <span class="dt">algorithm</span><span class="op">:</span> <span class="st">&#39;RS256&#39;</span> <span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<p>Sign asynchronously</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="va">jwt</span>.<span class="at">sign</span>(<span class="op">{</span> <span class="dt">foo</span><span class="op">:</span> <span class="st">&#39;bar&#39;</span> <span class="op">},</span> privateKey<span class="op">,</span> <span class="op">{</span> <span class="dt">algorithm</span><span class="op">:</span> <span class="st">&#39;RS256&#39;</span> <span class="op">},</span> <span class="kw">function</span>(err<span class="op">,</span> token) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="va">console</span>.<span class="at">log</span>(token)<span class="op">;</span></a>
<a class="sourceLine" id="cb4-3" title="3"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<p>Backdate a jwt 30 seconds</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">var</span> older_token <span class="op">=</span> <span class="va">jwt</span>.<span class="at">sign</span>(<span class="op">{</span> <span class="dt">foo</span><span class="op">:</span> <span class="st">&#39;bar&#39;</span><span class="op">,</span> <span class="dt">iat</span><span class="op">:</span> <span class="va">Math</span>.<span class="at">floor</span>(<span class="va">Date</span>.<span class="at">now</span>() / <span class="dv">1000</span>) <span class="op">-</span> <span class="dv">30</span> <span class="op">},</span> <span class="st">&#39;shhhhh&#39;</span>)<span class="op">;</span></a></code></pre></div>
<h4 id="token-expiration-exp-claim">Token Expiration (exp claim)</h4>
<p>The standard for JWT defines an <code>exp</code> claim for expiration. The expiration is represented as a <strong>NumericDate</strong>:</p>
<blockquote>
<p>A JSON numeric value representing the number of seconds from 1970-01-01T00:00:00Z UTC until the specified UTC date/time, ignoring leap seconds. This is equivalent to the IEEE Std 1003.1, 2013 Edition [POSIX.1] definition “Seconds Since the Epoch”, in which each day is accounted for by exactly 86400 seconds, other than that non-integer values can be represented. See RFC 3339 [RFC3339] for details regarding date/times in general and UTC in particular.</p>
</blockquote>
<p>This means that the <code>exp</code> field should contain the number of seconds since the epoch.</p>
<p>Signing a token with 1 hour of expiration:</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="va">jwt</span>.<span class="at">sign</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb6-2" title="2">  <span class="dt">exp</span><span class="op">:</span> <span class="va">Math</span>.<span class="at">floor</span>(<span class="va">Date</span>.<span class="at">now</span>() / <span class="dv">1000</span>) <span class="op">+</span> (<span class="dv">60</span> <span class="op">*</span> <span class="dv">60</span>)<span class="op">,</span></a>
<a class="sourceLine" id="cb6-3" title="3">  <span class="dt">data</span><span class="op">:</span> <span class="st">&#39;foobar&#39;</span></a>
<a class="sourceLine" id="cb6-4" title="4"><span class="op">},</span> <span class="st">&#39;secret&#39;</span>)<span class="op">;</span></a></code></pre></div>
<p>Another way to generate a token like this with this library is:</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="va">jwt</span>.<span class="at">sign</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb7-2" title="2">  <span class="dt">data</span><span class="op">:</span> <span class="st">&#39;foobar&#39;</span></a>
<a class="sourceLine" id="cb7-3" title="3"><span class="op">},</span> <span class="st">&#39;secret&#39;</span><span class="op">,</span> <span class="op">{</span> <span class="dt">expiresIn</span><span class="op">:</span> <span class="dv">60</span> <span class="op">*</span> <span class="dv">60</span> <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-4" title="4"></a>
<a class="sourceLine" id="cb7-5" title="5"><span class="co">//or even better:</span></a>
<a class="sourceLine" id="cb7-6" title="6"></a>
<a class="sourceLine" id="cb7-7" title="7"><span class="va">jwt</span>.<span class="at">sign</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb7-8" title="8">  <span class="dt">data</span><span class="op">:</span> <span class="st">&#39;foobar&#39;</span></a>
<a class="sourceLine" id="cb7-9" title="9"><span class="op">},</span> <span class="st">&#39;secret&#39;</span><span class="op">,</span> <span class="op">{</span> <span class="dt">expiresIn</span><span class="op">:</span> <span class="st">&#39;1h&#39;</span> <span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<h3 id="jwt.verifytoken-secretorpublickey-options-callback">jwt.verify(token, secretOrPublicKey, [options, callback])</h3>
<p>(Asynchronous) If a callback is supplied, function acts asynchronously. The callback is called with the decoded payload if the signature is valid and optional expiration, audience, or issuer are valid. If not, it will be called with the error.</p>
<p>(Synchronous) If a callback is not supplied, function acts synchronously. Returns the payload decoded if the signature is valid and optional expiration, audience, or issuer are valid. If not, it will throw the error.</p>
<blockquote>
<p><strong>Warning:</strong> When the token comes from an untrusted source (e.g. user input or external requests), the returned decoded payload should be treated like any other user input; please make sure to sanitize and only work with properties that are expected</p>
</blockquote>
<p><code>token</code> is the JsonWebToken string</p>
<p><code>secretOrPublicKey</code> is a string or buffer containing either the secret for HMAC algorithms, or the PEM encoded public key for RSA and ECDSA. If <code>jwt.verify</code> is called asynchronous, <code>secretOrPublicKey</code> can be a function that should fetch the secret or public key. See below for a detailed example</p>
<p>As mentioned in <a href="https://github.com/auth0/node-jsonwebtoken/issues/208#issuecomment-231861138">this comment</a>, there are other libraries that expect base64 encoded secrets (random bytes encoded using base64), if that is your case you can pass <code>Buffer.from(secret, 'base64')</code>, by doing this the secret will be decoded using base64 and the token verification will use the original random bytes.</p>
<p><code>options</code></p>
<ul>
<li><code>algorithms</code>: List of strings with the names of the allowed algorithms. For instance, <code>["HS256", "HS384"]</code>.</li>
<li><code>audience</code>: if you want to check audience (<code>aud</code>), provide a value here. The audience can be checked against a string, a regular expression or a list of strings and/or regular expressions. &gt; Eg: <code>"urn:foo"</code>, <code>/urn:f[o]{2}/</code>, <code>[/urn:f[o]{2}/, "urn:bar"]</code></li>
<li><code>complete</code>: return an object with the decoded <code>{ payload, header, signature }</code> instead of only the usual content of the payload.</li>
<li><code>issuer</code> (optional): string or array of strings of valid values for the <code>iss</code> field.</li>
<li><code>jwtid</code> (optional): if you want to check JWT ID (<code>jti</code>), provide a string value here.</li>
<li><code>ignoreExpiration</code>: if <code>true</code> do not validate the expiration of the token.</li>
<li><code>ignoreNotBefore</code>…</li>
<li><code>subject</code>: if you want to check subject (<code>sub</code>), provide a value here</li>
<li><code>clockTolerance</code>: number of seconds to tolerate when checking the <code>nbf</code> and <code>exp</code> claims, to deal with small clock differences among different servers</li>
<li><code>maxAge</code>: the maximum allowed age for tokens to still be valid. It is expressed in seconds or a string describing a time span <a href="https://github.com/vercel/ms">vercel/ms</a>. &gt; Eg: <code>1000</code>, <code>"2 days"</code>, <code>"10h"</code>, <code>"7d"</code>. A numeric value is interpreted as a seconds count. If you use a string be sure you provide the time units (days, hours, etc), otherwise milliseconds unit is used by default (<code>"120"</code> is equal to <code>"120ms"</code>).</li>
<li><code>clockTimestamp</code>: the time in seconds that should be used as the current time for all necessary comparisons.</li>
<li><code>nonce</code>: if you want to check <code>nonce</code> claim, provide a string value here. It is used on Open ID for the ID Tokens. (<a href="https://openid.net/specs/openid-connect-core-1_0.html#NonceNotes">Open ID implementation notes</a>)</li>
</ul>
<div class="sourceCode" id="cb8"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="co">// verify a token symmetric - synchronous</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="kw">var</span> decoded <span class="op">=</span> <span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> <span class="st">&#39;shhhhh&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-3" title="3"><span class="va">console</span>.<span class="at">log</span>(<span class="va">decoded</span>.<span class="at">foo</span>) <span class="co">// bar</span></a>
<a class="sourceLine" id="cb8-4" title="4"></a>
<a class="sourceLine" id="cb8-5" title="5"><span class="co">// verify a token symmetric</span></a>
<a class="sourceLine" id="cb8-6" title="6"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> <span class="st">&#39;shhhhh&#39;</span><span class="op">,</span> <span class="kw">function</span>(err<span class="op">,</span> decoded) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-7" title="7">  <span class="va">console</span>.<span class="at">log</span>(<span class="va">decoded</span>.<span class="at">foo</span>) <span class="co">// bar</span></a>
<a class="sourceLine" id="cb8-8" title="8"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-9" title="9"></a>
<a class="sourceLine" id="cb8-10" title="10"><span class="co">// invalid token - synchronous</span></a>
<a class="sourceLine" id="cb8-11" title="11"><span class="cf">try</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb8-12" title="12">  <span class="kw">var</span> decoded <span class="op">=</span> <span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> <span class="st">&#39;wrong-secret&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-13" title="13"><span class="op">}</span> <span class="cf">catch</span>(err) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-14" title="14">  <span class="co">// err</span></a>
<a class="sourceLine" id="cb8-15" title="15"><span class="op">}</span></a>
<a class="sourceLine" id="cb8-16" title="16"></a>
<a class="sourceLine" id="cb8-17" title="17"><span class="co">// invalid token</span></a>
<a class="sourceLine" id="cb8-18" title="18"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> <span class="st">&#39;wrong-secret&#39;</span><span class="op">,</span> <span class="kw">function</span>(err<span class="op">,</span> decoded) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-19" title="19">  <span class="co">// err</span></a>
<a class="sourceLine" id="cb8-20" title="20">  <span class="co">// decoded undefined</span></a>
<a class="sourceLine" id="cb8-21" title="21"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-22" title="22"></a>
<a class="sourceLine" id="cb8-23" title="23"><span class="co">// verify a token asymmetric</span></a>
<a class="sourceLine" id="cb8-24" title="24"><span class="kw">var</span> cert <span class="op">=</span> <span class="va">fs</span>.<span class="at">readFileSync</span>(<span class="st">&#39;public.pem&#39;</span>)<span class="op">;</span>  <span class="co">// get public key</span></a>
<a class="sourceLine" id="cb8-25" title="25"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> cert<span class="op">,</span> <span class="kw">function</span>(err<span class="op">,</span> decoded) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-26" title="26">  <span class="va">console</span>.<span class="at">log</span>(<span class="va">decoded</span>.<span class="at">foo</span>) <span class="co">// bar</span></a>
<a class="sourceLine" id="cb8-27" title="27"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-28" title="28"></a>
<a class="sourceLine" id="cb8-29" title="29"><span class="co">// verify audience</span></a>
<a class="sourceLine" id="cb8-30" title="30"><span class="kw">var</span> cert <span class="op">=</span> <span class="va">fs</span>.<span class="at">readFileSync</span>(<span class="st">&#39;public.pem&#39;</span>)<span class="op">;</span>  <span class="co">// get public key</span></a>
<a class="sourceLine" id="cb8-31" title="31"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> cert<span class="op">,</span> <span class="op">{</span> <span class="dt">audience</span><span class="op">:</span> <span class="st">&#39;urn:foo&#39;</span> <span class="op">},</span> <span class="kw">function</span>(err<span class="op">,</span> decoded) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-32" title="32">  <span class="co">// if audience mismatch, err == invalid audience</span></a>
<a class="sourceLine" id="cb8-33" title="33"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-34" title="34"></a>
<a class="sourceLine" id="cb8-35" title="35"><span class="co">// verify issuer</span></a>
<a class="sourceLine" id="cb8-36" title="36"><span class="kw">var</span> cert <span class="op">=</span> <span class="va">fs</span>.<span class="at">readFileSync</span>(<span class="st">&#39;public.pem&#39;</span>)<span class="op">;</span>  <span class="co">// get public key</span></a>
<a class="sourceLine" id="cb8-37" title="37"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> cert<span class="op">,</span> <span class="op">{</span> <span class="dt">audience</span><span class="op">:</span> <span class="st">&#39;urn:foo&#39;</span><span class="op">,</span> <span class="dt">issuer</span><span class="op">:</span> <span class="st">&#39;urn:issuer&#39;</span> <span class="op">},</span> <span class="kw">function</span>(err<span class="op">,</span> decoded) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-38" title="38">  <span class="co">// if issuer mismatch, err == invalid issuer</span></a>
<a class="sourceLine" id="cb8-39" title="39"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-40" title="40"></a>
<a class="sourceLine" id="cb8-41" title="41"><span class="co">// verify jwt id</span></a>
<a class="sourceLine" id="cb8-42" title="42"><span class="kw">var</span> cert <span class="op">=</span> <span class="va">fs</span>.<span class="at">readFileSync</span>(<span class="st">&#39;public.pem&#39;</span>)<span class="op">;</span>  <span class="co">// get public key</span></a>
<a class="sourceLine" id="cb8-43" title="43"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> cert<span class="op">,</span> <span class="op">{</span> <span class="dt">audience</span><span class="op">:</span> <span class="st">&#39;urn:foo&#39;</span><span class="op">,</span> <span class="dt">issuer</span><span class="op">:</span> <span class="st">&#39;urn:issuer&#39;</span><span class="op">,</span> <span class="dt">jwtid</span><span class="op">:</span> <span class="st">&#39;jwtid&#39;</span> <span class="op">},</span> <span class="kw">function</span>(err<span class="op">,</span> decoded) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-44" title="44">  <span class="co">// if jwt id mismatch, err == invalid jwt id</span></a>
<a class="sourceLine" id="cb8-45" title="45"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-46" title="46"></a>
<a class="sourceLine" id="cb8-47" title="47"><span class="co">// verify subject</span></a>
<a class="sourceLine" id="cb8-48" title="48"><span class="kw">var</span> cert <span class="op">=</span> <span class="va">fs</span>.<span class="at">readFileSync</span>(<span class="st">&#39;public.pem&#39;</span>)<span class="op">;</span>  <span class="co">// get public key</span></a>
<a class="sourceLine" id="cb8-49" title="49"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> cert<span class="op">,</span> <span class="op">{</span> <span class="dt">audience</span><span class="op">:</span> <span class="st">&#39;urn:foo&#39;</span><span class="op">,</span> <span class="dt">issuer</span><span class="op">:</span> <span class="st">&#39;urn:issuer&#39;</span><span class="op">,</span> <span class="dt">jwtid</span><span class="op">:</span> <span class="st">&#39;jwtid&#39;</span><span class="op">,</span> <span class="dt">subject</span><span class="op">:</span> <span class="st">&#39;subject&#39;</span> <span class="op">},</span> <span class="kw">function</span>(err<span class="op">,</span> decoded) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-50" title="50">  <span class="co">// if subject mismatch, err == invalid subject</span></a>
<a class="sourceLine" id="cb8-51" title="51"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-52" title="52"></a>
<a class="sourceLine" id="cb8-53" title="53"><span class="co">// alg mismatch</span></a>
<a class="sourceLine" id="cb8-54" title="54"><span class="kw">var</span> cert <span class="op">=</span> <span class="va">fs</span>.<span class="at">readFileSync</span>(<span class="st">&#39;public.pem&#39;</span>)<span class="op">;</span> <span class="co">// get public key</span></a>
<a class="sourceLine" id="cb8-55" title="55"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> cert<span class="op">,</span> <span class="op">{</span> <span class="dt">algorithms</span><span class="op">:</span> [<span class="st">&#39;RS256&#39;</span>] <span class="op">},</span> <span class="kw">function</span> (err<span class="op">,</span> payload) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-56" title="56">  <span class="co">// if token alg != RS256,  err == invalid signature</span></a>
<a class="sourceLine" id="cb8-57" title="57"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-58" title="58"></a>
<a class="sourceLine" id="cb8-59" title="59"><span class="co">// Verify using getKey callback</span></a>
<a class="sourceLine" id="cb8-60" title="60"><span class="co">// Example uses https://github.com/auth0/node-jwks-rsa as a way to fetch the keys.</span></a>
<a class="sourceLine" id="cb8-61" title="61"><span class="kw">var</span> jwksClient <span class="op">=</span> <span class="at">require</span>(<span class="st">&#39;jwks-rsa&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-62" title="62"><span class="kw">var</span> client <span class="op">=</span> <span class="at">jwksClient</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb8-63" title="63">  <span class="dt">jwksUri</span><span class="op">:</span> <span class="st">&#39;https://sandrino.auth0.com/.well-known/jwks.json&#39;</span></a>
<a class="sourceLine" id="cb8-64" title="64"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-65" title="65"><span class="kw">function</span> <span class="at">getKey</span>(header<span class="op">,</span> callback)<span class="op">{</span></a>
<a class="sourceLine" id="cb8-66" title="66">  <span class="va">client</span>.<span class="at">getSigningKey</span>(<span class="va">header</span>.<span class="at">kid</span><span class="op">,</span> <span class="kw">function</span>(err<span class="op">,</span> key) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-67" title="67">    <span class="kw">var</span> signingKey <span class="op">=</span> <span class="va">key</span>.<span class="at">publicKey</span> <span class="op">||</span> <span class="va">key</span>.<span class="at">rsaPublicKey</span><span class="op">;</span></a>
<a class="sourceLine" id="cb8-68" title="68">    <span class="at">callback</span>(<span class="kw">null</span><span class="op">,</span> signingKey)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-69" title="69">  <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-70" title="70"><span class="op">}</span></a>
<a class="sourceLine" id="cb8-71" title="71"></a>
<a class="sourceLine" id="cb8-72" title="72"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> getKey<span class="op">,</span> options<span class="op">,</span> <span class="kw">function</span>(err<span class="op">,</span> decoded) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-73" title="73">  <span class="va">console</span>.<span class="at">log</span>(<span class="va">decoded</span>.<span class="at">foo</span>) <span class="co">// bar</span></a>
<a class="sourceLine" id="cb8-74" title="74"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<details>
<p><summary><em></em>Need to peek into a JWT without verifying it? (Click to expand)</summary></p>
<h3 id="jwt.decodetoken-options">jwt.decode(token [, options])</h3>
<p>(Synchronous) Returns the decoded payload without verifying if the signature is valid.</p>
<blockquote>
<p><strong>Warning:</strong> This will <strong>not</strong> verify whether the signature is valid. You should <strong>not</strong> use this for untrusted messages. You most likely want to use <code>jwt.verify</code> instead.</p>
</blockquote>
<blockquote>
<p><strong>Warning:</strong> When the token comes from an untrusted source (e.g. user input or external request), the returned decoded payload should be treated like any other user input; please make sure to sanitize and only work with properties that are expected</p>
</blockquote>
<p><code>token</code> is the JsonWebToken string</p>
<p><code>options</code>:</p>
<ul>
<li><code>json</code>: force JSON.parse on the payload even if the header doesn’t contain <code>"typ":"JWT"</code>.</li>
<li><code>complete</code>: return an object with the decoded payload and header.</li>
</ul>
<p>Example</p>
<div class="sourceCode" id="cb9"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="co">// get the decoded payload ignoring signature, no secretOrPrivateKey needed</span></a>
<a class="sourceLine" id="cb9-2" title="2"><span class="kw">var</span> decoded <span class="op">=</span> <span class="va">jwt</span>.<span class="at">decode</span>(token)<span class="op">;</span></a>
<a class="sourceLine" id="cb9-3" title="3"></a>
<a class="sourceLine" id="cb9-4" title="4"><span class="co">// get the decoded payload and header</span></a>
<a class="sourceLine" id="cb9-5" title="5"><span class="kw">var</span> decoded <span class="op">=</span> <span class="va">jwt</span>.<span class="at">decode</span>(token<span class="op">,</span> <span class="op">{</span><span class="dt">complete</span><span class="op">:</span> <span class="kw">true</span><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb9-6" title="6"><span class="va">console</span>.<span class="at">log</span>(<span class="va">decoded</span>.<span class="at">header</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb9-7" title="7"><span class="va">console</span>.<span class="at">log</span>(<span class="va">decoded</span>.<span class="at">payload</span>)</a></code></pre></div>
</details>
<h2 id="errors-codes">Errors &amp; Codes</h2>
<p>Possible thrown errors during verification. Error is the first argument of the verification callback.</p>
<h3 id="tokenexpirederror">TokenExpiredError</h3>
<p>Thrown error if the token is expired.</p>
<p>Error object:</p>
<ul>
<li>name: ‘TokenExpiredError’</li>
<li>message: ‘jwt expired’</li>
<li>expiredAt: [ExpDate]</li>
</ul>
<div class="sourceCode" id="cb10"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> <span class="st">&#39;shhhhh&#39;</span><span class="op">,</span> <span class="kw">function</span>(err<span class="op">,</span> decoded) <span class="op">{</span></a>
<a class="sourceLine" id="cb10-2" title="2">  <span class="cf">if</span> (err) <span class="op">{</span></a>
<a class="sourceLine" id="cb10-3" title="3">    <span class="co">/*</span></a>
<a class="sourceLine" id="cb10-4" title="4"><span class="co">      err = {</span></a>
<a class="sourceLine" id="cb10-5" title="5"><span class="co">        name: &#39;TokenExpiredError&#39;,</span></a>
<a class="sourceLine" id="cb10-6" title="6"><span class="co">        message: &#39;jwt expired&#39;,</span></a>
<a class="sourceLine" id="cb10-7" title="7"><span class="co">        expiredAt: 1408621000</span></a>
<a class="sourceLine" id="cb10-8" title="8"><span class="co">      }</span></a>
<a class="sourceLine" id="cb10-9" title="9"><span class="co">    */</span></a>
<a class="sourceLine" id="cb10-10" title="10">  <span class="op">}</span></a>
<a class="sourceLine" id="cb10-11" title="11"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<h3 id="jsonwebtokenerror">JsonWebTokenError</h3>
<p>Error object:</p>
<ul>
<li>name: ‘JsonWebTokenError’</li>
<li>message:
<ul>
<li>‘invalid token’ - the header or payload could not be parsed</li>
<li>‘jwt malformed’ - the token does not have three components (delimited by a <code>.</code>)</li>
<li>‘jwt signature is required’</li>
<li>‘invalid signature’</li>
<li>‘jwt audience invalid. expected: [OPTIONS AUDIENCE]’</li>
<li>‘jwt issuer invalid. expected: [OPTIONS ISSUER]’</li>
<li>‘jwt id invalid. expected: [OPTIONS JWT ID]’</li>
<li>‘jwt subject invalid. expected: [OPTIONS SUBJECT]’</li>
</ul></li>
</ul>
<div class="sourceCode" id="cb11"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> <span class="st">&#39;shhhhh&#39;</span><span class="op">,</span> <span class="kw">function</span>(err<span class="op">,</span> decoded) <span class="op">{</span></a>
<a class="sourceLine" id="cb11-2" title="2">  <span class="cf">if</span> (err) <span class="op">{</span></a>
<a class="sourceLine" id="cb11-3" title="3">    <span class="co">/*</span></a>
<a class="sourceLine" id="cb11-4" title="4"><span class="co">      err = {</span></a>
<a class="sourceLine" id="cb11-5" title="5"><span class="co">        name: &#39;JsonWebTokenError&#39;,</span></a>
<a class="sourceLine" id="cb11-6" title="6"><span class="co">        message: &#39;jwt malformed&#39;</span></a>
<a class="sourceLine" id="cb11-7" title="7"><span class="co">      }</span></a>
<a class="sourceLine" id="cb11-8" title="8"><span class="co">    */</span></a>
<a class="sourceLine" id="cb11-9" title="9">  <span class="op">}</span></a>
<a class="sourceLine" id="cb11-10" title="10"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<h3 id="notbeforeerror">NotBeforeError</h3>
<p>Thrown if current time is before the nbf claim.</p>
<p>Error object:</p>
<ul>
<li>name: ‘NotBeforeError’</li>
<li>message: ‘jwt not active’</li>
<li>date: 2018-10-04T16:10:44.000Z</li>
</ul>
<div class="sourceCode" id="cb12"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1"><span class="va">jwt</span>.<span class="at">verify</span>(token<span class="op">,</span> <span class="st">&#39;shhhhh&#39;</span><span class="op">,</span> <span class="kw">function</span>(err<span class="op">,</span> decoded) <span class="op">{</span></a>
<a class="sourceLine" id="cb12-2" title="2">  <span class="cf">if</span> (err) <span class="op">{</span></a>
<a class="sourceLine" id="cb12-3" title="3">    <span class="co">/*</span></a>
<a class="sourceLine" id="cb12-4" title="4"><span class="co">      err = {</span></a>
<a class="sourceLine" id="cb12-5" title="5"><span class="co">        name: &#39;NotBeforeError&#39;,</span></a>
<a class="sourceLine" id="cb12-6" title="6"><span class="co">        message: &#39;jwt not active&#39;,</span></a>
<a class="sourceLine" id="cb12-7" title="7"><span class="co">        date: 2018-10-04T16:10:44.000Z</span></a>
<a class="sourceLine" id="cb12-8" title="8"><span class="co">      }</span></a>
<a class="sourceLine" id="cb12-9" title="9"><span class="co">    */</span></a>
<a class="sourceLine" id="cb12-10" title="10">  <span class="op">}</span></a>
<a class="sourceLine" id="cb12-11" title="11"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<h2 id="algorithms-supported">Algorithms supported</h2>
<p>Array of supported algorithms. The following algorithms are currently supported.</p>
<table>
<colgroup>
<col style="width: 36%" />
<col style="width: 63%" />
</colgroup>
<thead>
<tr class="header">
<th>alg Parameter Value</th>
<th>Digital Signature or MAC Algorithm</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>HS256</td>
<td>HMAC using SHA-256 hash algorithm</td>
</tr>
<tr class="even">
<td>HS384</td>
<td>HMAC using SHA-384 hash algorithm</td>
</tr>
<tr class="odd">
<td>HS512</td>
<td>HMAC using SHA-512 hash algorithm</td>
</tr>
<tr class="even">
<td>RS256</td>
<td>RSASSA-PKCS1-v1_5 using SHA-256 hash algorithm</td>
</tr>
<tr class="odd">
<td>RS384</td>
<td>RSASSA-PKCS1-v1_5 using SHA-384 hash algorithm</td>
</tr>
<tr class="even">
<td>RS512</td>
<td>RSASSA-PKCS1-v1_5 using SHA-512 hash algorithm</td>
</tr>
<tr class="odd">
<td>PS256</td>
<td>RSASSA-PSS using SHA-256 hash algorithm (only node ^6.12.0 OR &gt;=8.0.0)</td>
</tr>
<tr class="even">
<td>PS384</td>
<td>RSASSA-PSS using SHA-384 hash algorithm (only node ^6.12.0 OR &gt;=8.0.0)</td>
</tr>
<tr class="odd">
<td>PS512</td>
<td>RSASSA-PSS using SHA-512 hash algorithm (only node ^6.12.0 OR &gt;=8.0.0)</td>
</tr>
<tr class="even">
<td>ES256</td>
<td>ECDSA using P-256 curve and SHA-256 hash algorithm</td>
</tr>
<tr class="odd">
<td>ES384</td>
<td>ECDSA using P-384 curve and SHA-384 hash algorithm</td>
</tr>
<tr class="even">
<td>ES512</td>
<td>ECDSA using P-521 curve and SHA-512 hash algorithm</td>
</tr>
<tr class="odd">
<td>none</td>
<td>No digital signature or MAC value included</td>
</tr>
</tbody>
</table>
<h2 id="refreshing-jwts">Refreshing JWTs</h2>
<p>First of all, we recommend you to think carefully if auto-refreshing a JWT will not introduce any vulnerability in your system.</p>
<p>We are not comfortable including this as part of the library, however, you can take a look at <a href="https://gist.github.com/ziluvatar/a3feb505c4c0ec37059054537b38fc48">this example</a> to show how this could be accomplished. Apart from that example there are <a href="https://github.com/auth0/node-jsonwebtoken/issues/122">an issue</a> and <a href="https://github.com/auth0/node-jsonwebtoken/pull/172">a pull request</a> to get more knowledge about this topic.</p>
<h1 id="todo">TODO</h1>
<ul>
<li>X.509 certificate chain is not checked</li>
</ul>
<h2 id="issue-reporting">Issue Reporting</h2>
<p>If you have found a bug or if you have a feature request, please report them at this repository issues section. Please do not report security vulnerabilities on the public GitHub issue tracker. The <a href="https://auth0.com/whitehat">Responsible Disclosure Program</a> details the procedure for disclosing security issues.</p>
<h2 id="author">Author</h2>
<p><a href="https://auth0.com">Auth0</a></p>
<h2 id="license">License</h2>
<p>This project is licensed under the MIT license. See the <a href="LICENSE">LICENSE</a> file for more info.</p>
</body>
</html>
